unit FXUnit;

interface

uses Windows,Classes,DXDraws,DIB,VGraph,Graphics,VConsts,VFunc;


type

 PField=^TField;
 TField=array[0..99,0..159]of Word;

 TFireFX=class
          Field:PField;
          FDib:TDiB;
          Color:TColor;
          Fadeprocess:long;
          Fadeout:boolean;

          Surface:TAutoSurf;
          constructor Create(Col:TColor);
          destructor Destroy;override;

          procedure Redraw(Surf:TAutoSurf;R:TRect);

          procedure UpdateSurf;
         end;

implementation

constructor TFireFX.Create(Col:TColor);
var r,g,b:byte;
    i:long;
begin
 inherited Create;
 Color:=Col;
 New(Field);
 Zeromemory(Field, 32000);


 GetRGB(ColorTORGB(Color),r,g,b);

 FDIB:=TDIB.Create;
 FDIB.SetSize(320,200,8);


 for i:=0 to 255 do
  begin
  FDIB.ColorTable[i].rgbRed:=Round(r/255*i);
  FDIB.ColorTable[i].rgbBlue:=Round(b/255*i);
  FDIB.ColorTable[i].rgbGreen:=Round(g/255*i);
 end;
 FDIB.UpdatePalette;
 FDib.Transparent:=false;

end;

destructor TFireFX.Destroy;
begin
// FDib.Free;

// Surface.free;
// inherited Destroy;
end;

procedure TFireFX.UpdateSurf;
 begin
  if Surface=nil then Exit;
  if Surface.Surf=nil then Exit;
  Surface.Surf.SetSize(320,200);
  Surface.Surf.Fill(0);
 end;

procedure TFireFX.Redraw(Surf:TAutoSurf;R:TRect);

procedure DoFlame;
type
  Giant = array[0..$FFFE] of byte;
var
  FieldPtr, BitmapPtr: Pointer;
  y, x, w, ax, fpt, bpt: Word;
  bt: Array[1..2] of Byte;

  begin
  FieldPtr := Field;
  BitmapPtr := fdib.pbits;

     ;
  for y := 0 to 97 do
   begin
    bpt := 640 * (99 - y);
    fpt := 320 * y;
    for x := 1 to 160 do
     begin
      move(Giant(FieldPtr^)[fpt + 159 * 2], w, 2);
      ax := w;
      move(Giant(FieldPtr^)[fpt + 160 * 2], w, 2);
      ax := w + ax;
      move(Giant(FieldPtr^)[fpt + 161 * 2], w, 2);
      ax := w + ax;
      move(Giant(FieldPtr^)[fpt + 320 * 2], w, 2);
      ax := w + ax;
      ax := ax shr 2;
      if ax <> 0 then dec(ax);
      move(ax, Giant(FieldPtr^)[fpt], 2);
      inc(fpt, 2);
      bt[1] := Lo(ax);
      bt[2] := bt[1];
      Move(bt, ax, 2);


     move(ax,Giant(BitmapPtr^)[bpt - 1], 2);
     move(ax,Giant(BitmapPtr^)[bpt - 321], 2);

      dec(bpt, 2);
     end;end;


//dibb.blur(8,2);
     end;

procedure MakeRandomLine(y:long);
var
  x: Word;
begin
  for x := 10 to 149 do
   //case Random(2)of
//   Field^[y, x] := Random(2)*Round(Random(256-Abs(x-85)*2)*1.8);
//
     Field^[y, x] := Random(2)*Min(255,Round(Random(256-Abs(x-85)*2)*2.1));

   end;

procedure MakeDarkLine(y:long);
var
  x: Word;
begin
  for x := 10 to 149 do
   Field^[y, x] := Random(2) + Random(FadeProcess);


  if FadeProcess > 0 then dec(FadeProcess)
  else
   begin
   // Enabled := False;
    FadeOut := False;
    FadeProcess := 255;
  //  Paint;
  end;
end;



var SR:TRect;

begin
   if not FadeOut then
   begin
    MakeRandomLine(98+Random(2))
   ; MakeRandomLine(97+Random(2))
                ;
   //else
  //MakeRandomLine(98)
  end
  else
   begin
// { if random(2)=1 then } MakeDarkLine(98+Random(2));
  // MakeDarkLine(97);
   end   ;
  DoFlame;

if Surface=nil then
begin
Surface:=TAutoSurf.Create(Surf.Draw,UpdateSurf);
UpdateSurf;
end
else
begin
Surface.Surf.Fill(0);
Surface.Surf.Canvas.Draw(0,0,fdib);
Surface.Surf.Canvas.Release;
SR:=Surface.Surf.ClientRect;
DrawROP(Surf.Surf,Surface.Surf,R,Rect(SR.Left,SR.Top,SR.Right,SR.Bottom-10),SRCPAINT);
end;


end;

end.

