unit MorkinClass;

interface

uses Windows, Classes, SysUtils, Controller, DXDraws, DXSounds, MIDPlay, MIDList,
  AStream, VStream, VTextList, GameClass, VFunc, VGraph, VConsts, CtrlMsg, StdObj,
  M3Consts, ExtObj,Engine,Forms,Graphics,FXUnit



  ;


type

  TWinCtrl = class
  public
    Desk,
      MainMenu,
      Options,
      OptGFX,
      OptMIDI,
      Newgamemain,
      NewGameChar,
      NewGameStory,
      NewGameMap,
      LoadGame,
      MainView,
      S1Unit,
      S2Player,
      S3Menu,
      Info,
      Credits

      : TVForm;

      SurfDrawer,
      UnitDrawer,
      PlayerDrawer,
      CreditsDrawer

      :TVSurfDrawer;

    procedure Init(AWC: TController);

  end;

  TUpdater=class
           public
            Wins:TWinCtrl;
            Engine:TEngine;

            constructor Create(AWins:TWinCtrl;AEngine:TEngine);

            function UpdateUnitValues(AUnit:TChar):boolean;
            function UpdateUnitImg(AUnit:TChar):boolean;
            function UpdateUnitAll(AUnit:TChar):boolean;

            function UpdatePlayerValues(APlayer:TPlayer):boolean;
            function UpdatePlayerImg(APlayer:TPlayer):boolean;
            function UpdatePlayerAll(APlayer:TPlayer):boolean;

            function UpdateAll:boolean;


            procedure RedrawUnit(Sender:TObject);
            procedure RedrawPlayer(Sender:TObject);

           end;

  TPlayerInfo=record
               Name:string;
               Color:TColor;
               Human:boolean;
               PClass:long;
               RandomClass:boolean;

              end;



  TPInfos=array[1..MAX_PLAYERS]of TPlayerInfo;


  TMorkin3 = class(TVGame)
  private


    procedure MoveInGame;

  protected
    procedure SetState(Value: long); override;

    function NextCol(Col:TColor):TColor;
    function PrevCol(Col:TColor):TColor;

  public
    Wins: TWinCtrl;
    Updater:TUpdater;
    Players: long;
    Campaign:boolean;

    Engine:TEngine;

    PInfos:TPInfos;
    APlayer:long;

    FireFX:TFireFX;

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Define; override;
    procedure LoadWindows(FileName: string); override;
    procedure LoadData; override;
    procedure ReadCfg;override;
    procedure WriteCfg;override;

    procedure SetDefaults; override;
    procedure Quit; override;

    procedure CtrlHandler(Win: TVWinControl; Ctrl: TVControl; MSG: TVMSG); override;
    procedure GlobalHandler(MSG: TVMSG); override;

    procedure ShowWindows(Wins: array of TVForm; Hide: boolean = true); override;

    procedure DrawCredits(Sender:TObject);
    procedure BeforeDestruction;override;

  published

  end;





implementation


constructor TMorkin3.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

end;


destructor TMorkin3.Destroy;
begin
  Engine.Free;
  inherited Destroy;
end;

procedure TMorkin3.Define;
var i:long;
begin
  inherited;
  Title := 'Morkin 3';
  Developer := 'Vampyre SoftWoks';
  CfgFile:= ExeDir+FILE_CFG;
  WinFile := Exedir + FILE_WINDOWS;
  ShowFPS := true;
  Players:=1;
  Campaign:=true;

  for i:=1 to MAX_PLAYERS do
   with PInfos[i] do
   begin
    Name:='Neznm Hrdina';
    Color:=Playercolors[i];
    Human:=false;
    RandomClass:=false;
    PClass:=0;
   end;
  PInfos[1].Human:=true;
  APlayer:=1;
end;

procedure TMorkin3.LoadData;
begin
  MIDList.Items.LoadFromFile(ExeDir + FILE_MIDI);
  TextList.Items.LoadFromFile(ExeDir + FILE_TEXT);
  AddFontResource(PChar(ExeDir + FILE_FONT_AMHERST));

end;

procedure TMorkin3.SetDefaults;
begin
  inherited;
  MIDPlay.PlayList.Options := [poShuffle, poContinuous];

  Engine:=TEngine.Create(Self);
  Updater:=TUpdater.Create(Wins,Engine);

end;

procedure TMorkin3.ReadCfg;
begin
 with INIFile do
 begin
  FullScreen:=ReadBool('Graphic','FullScreen',false);
  SystemMem:=ReadBool('Graphic','SystemMem',false);
  VBlank:=ReadBool('Graphic','VBlank',true);
  ShowFPS:=ReadBool('Graphic','ShowFPS',false);
  SetRes(ReadInteger('Graphic','Width',800),ReadInteger('Graphic','Height',600),ReadInteger('Graphic','BitCount',32));
  PlayMIDI:=ReadBool('MIDI','PlayMIDI',PlayMIDI);

 end;
end;


procedure TMorkin3.WriteCfg;
begin
 with INIFile do
 begin
  WriteBool('Graphic','FullScreen',FullScreen);
  WriteBool('Graphic','SystemMem',SystemMem);
  WriteBool('Graphic','VBlank',VBlank);
  WriteBool('Graphic','ShowFPS',ShowFPS);
  WriteInteger('Graphic','Width',DisplayWidth);
  WriteInteger('Graphic','Height',DisplayHeight);
  WriteInteger('Graphic','Bits',DisplayBitCount);
  WriteBool('MIDI','PlayMIDI',PlayMIDI);

 end;
end;

procedure TMorkin3.LoadWindows(FileName: string);
begin
  inherited;
  FireFX:=TFireFX.Create(clAqua);

  Wins := TWinCtrl.Create;
  Wins.Init(WC);

  Wins.CreditsDrawer.OnDraw:=DrawCredits;
end;

procedure TMorkin3.Quit;
begin
//  FireFX.Free;

  inherited;
end;

procedure TMorkin3.BeforeDestruction;
begin
// inherited;
 //FireFX.Free;
 //Engine.Unload;

end;

procedure TMorkin3.CtrlHandler(Win: TVWinControl; Ctrl: TVControl; MSG: TVMSG);
begin
  inherited;
  with Wins do
  begin
    case MSG.Message of
      MSG_CLICK:
        begin
          /////
          if Win = Mainmenu then
          begin
            if CompStr(Ctrl.Name, 'Btn_EXIT') then Quit;
            if CompStr(Ctrl.Name, 'Btn_NEWGAME') then State := ST_NEWGAME;
            if CompStr(Ctrl.Name, 'Btn_LOADGAME') then LoadGame.Show;
            if CompStr(Ctrl.Name, 'Btn_OPTIONS') then Options.Show;


            if CompStr(Ctrl.Name, 'Btn_INFO') then Info.Show;

          end;
          //////
          if Win = NewGameMain then
          begin

            if CompStr(Ctrl.Name, 'Btn_PREV') then State := ST_MAINMENU;
            if CompStr(Ctrl.Name, 'Btn_NEXT') then begin NewgameChar.Show; NewGamemain.Hide;end;


          end;
          //////
          if Win = NewGameChar then
          begin

            if CompStr(Ctrl.Name, 'Btn_PREV') then
            begin NewGameChar.Hide;
             if APlayer=1 then NewGamemain.Show
             else begin Dec(APlayer);NewGameChar.Show;end;
            end;

            if CompStr(Ctrl.Name, 'Btn_NEXT') then
            begin NewGameChar.Hide;
            if APlayer=Players then
            if Campaign then NewgameStory.Show else Newgamemap.Show
            else begin Inc(APlayer);NewgameChar.Show;end;
            end;

            if CompStr(Ctrl.Name,'Btn_Next_CL')then
             begin
             PInfos[APlayer].Color:=NextCol(PInfos[APlayer].Color);
             TVGraphControl(Win.Ctrl('Pan_Color')).Color:=PInfos[APlayer].Color;
             end;

            if CompStr(Ctrl.Name,'Btn_Prev_CL')then
             begin
             PInfos[APlayer].Color:=PrevCol(PInfos[APlayer].Color);
             TVGraphControl(Win.Ctrl('Pan_Color')).Color:=PInfos[APlayer].Color;
             end;


          end;
         ////////
          if Win = NewGameStory then
          begin

            if CompStr(Ctrl.Name, 'Btn_PREV') then
            begin ShowWindows([NewgameChar], false); NewGameStory.Hide;
            end;
            if CompStr(Ctrl.Name, 'Btn_NEXT') then State:=ST_INGAME;


          end;
          ///////
          if Win = NewGameMap then
          begin

            if CompStr(Ctrl.Name, 'Btn_PREV') then begin NewgameChar.Show; NewGameMap.Hide;end;
            if CompStr(Ctrl.Name, 'Btn_NEXT') then State:=ST_INGAME;

          end;
          ///////
          ///////
          if Win = LoadGame then
          begin

            if CompStr(Ctrl.Name, 'Btn_PREV') then LoadGame.Hide;


          end;
          ///////
          if Win = Options then
          begin

            if CompStr(Ctrl.Name, 'Btn_PREV') then
              Options.Hide;

            if CompStr(Ctrl.Name, 'Btn_GFX') then ShowWindows([OptGFX], false);
            if CompStr(Ctrl.Name, 'Btn_Music') then ShowWindows([OptMIDI], false);


          end;
          //////
          if Win = OptGFX then
          begin

            if CompStr(Ctrl.Name, 'Btn_PREV') then
            begin OptGFX.Hide; Options.Show;end;

            if CompStr(Ctrl.Name,'Btn_800x16')then
              SetRes(800,600,16);
            if CompStr(Ctrl.Name,'Btn_800x32')then
              SetRes(800,600,32);
            if CompStr(Ctrl.Name,'Btn_1024x16')then
              SetRes(1024,768,16);
            if CompStr(Ctrl.Name,'Btn_1024x32')then
              SetRes(1024,768,32);


          end;
          //////
          if Win = OptMIDI then
          begin

            if CompStr(Ctrl.Name, 'Btn_PREV') then
            begin OptMIDI.Hide; Options.Show;
            end;


          end;
          //////
          if Win = Info then
          begin

            if CompStr(Ctrl.Name, 'Btn_PREV') then Info.Hide;
            if CompStr(Ctrl.Name, 'Btn_Credits') then Credits.Show;


          end;
          //////
          if Win = Credits then
          begin

            if CompStr(Ctrl.Name, 'Btn_PREV') then Credits.Hide;
         

          end;
          //////


          ///////////////  INGAME  /////////////
          //////////////////////////////////////
          if Win = S3Menu then
          begin

             if CompStr(Ctrl.Name, 'Btn_Menu') then State:=ST_MAINMENU;
             if CompStr(Ctrl.Name,'Btn_Exit') then Quit;
             if CompStr(Ctrl.Name,'Btn_Opt') then Options.Show;



          end;
          //////////
          if Win = S1Unit then
          begin

             if CompStr(Ctrl.Name, 'Btn_Next') then Engine.NextUnit;
             if CompStr(Ctrl.Name, 'Btn_Prev') then Engine.PrevUnit;


          end;
          //////////
          if Win = S2Player then
          begin

             if CompStr(Ctrl.Name, 'Btn_Next') then Engine.NextPlayer;
             if CompStr(Ctrl.Name, 'Btn_Prev') then Engine.PrevPlayer;


          end;
          //////////







        end;

      MSG_CHANGE:
        begin
          //////////
          if Win = NewGameMain then
          begin
            if CompStr(Ctrl.Name,'CB_Camp') then
              TVCheckBox(Win.Ctrl('CB_Custom')).Checked := not TVCheckBox(Ctrl).Checked;;
            if CompStr(Ctrl.Name, 'CB_Custom') then
              TVCheckBox(Win.Ctrl('CB_Camp')).Checked := not TVCheckBox(Ctrl).Checked;
            if CompStr(Ctrl.Name,'SE_Players')then Players:=TVSpinEdit(Ctrl).Value;

            Campaign:=TVCheckBox(Win.Ctrl('CB_Camp')).Checked;
          end;
          ///////////
          if Win = OptGFX then
          begin
            if CompStr(Ctrl.name, 'CB_Sysmem') then
              SystemMem:=TVCheckBox(Ctrl).Checked;
            if CompStr(Ctrl.name, 'CB_VBlank') then
              VBlank:=TVCheckBox(Ctrl).Checked;
            if CompStr(Ctrl.name, 'CB_Full') then
              FullScreen:=TVCheckBox(Ctrl).Checked;
            if CompStr(Ctrl.name, 'CB_FPS') then
              ShowFPS:=TVCheckBox(Ctrl).Checked;

            if CompStrArray(ctrl.Name,['CB_Full','Btn_800x16','Btn_800x32','Btn_1024x16','Btn_1024x32']) then
             TVPanel(OptGFX.Ctrl('Lab_Res')).Caption:=Format('%dx%dx%d',[DisplayWidth,DisplayHeight,DisplayBitCount]);


           end;
           /////////
          if Win = OptMIDI then
          begin
            if CompStr(Ctrl.name, 'CB_Play') then
              begin
              PlayMIDI:=TVCheckBox(Ctrl).Checked;
              if PlayMIDI then MIDPlay.PlayList.Restart(true)
              else MIDPlay.StopAll;


              end;
           end;
           /////////
          if Win = NewGameChar then
          begin
            if CompStr(Ctrl.name, 'CB_Random') then
              PInfos[APlayer].RandomClass:=TVCheckBox(Ctrl).Checked;

            if CompStr(Ctrl.Name,'CB_Human') then
              TVCheckBox(Win.Ctrl('CB_CPU')).Checked := not TVCheckBox(Ctrl).Checked;;
            if CompStr(Ctrl.Name, 'CB_CPU') then
              TVCheckBox(Win.Ctrl('CB_Human')).Checked := not TVCheckBox(Ctrl).Checked;

            PInfos[APlayer].Human:=TVCheckBox(Win.Ctrl('CB_Human')).Checked;

            if CompStr(Ctrl.name, 'Ed_Name') then
             PInfos[APlayer].Name:=TVEdit(Ctrl).Text;

           end;
           /////////



        end;

      MSG_SHOW:
        begin
          ////
          if Ctrl = NewGameMain then
          begin
            TVCheckBox(TVForm(Ctrl).Ctrl('CB_Camp')).Checked := Campaign;
            TVCheckBox(TVForm(Ctrl).Ctrl('CB_Custom')).Checked := not Campaign;
            TVSpinEdit(TVForm(Ctrl).Ctrl('SE_Players')).Value:=Players;
          end;
          ////
          if Ctrl = OptGFX then
          begin
            TVCheckBox(TVForm(Ctrl).Ctrl('CB_Full')).Checked := FullScreen;
            TVCheckBox(TVForm(Ctrl).Ctrl('CB_SysMem')).Checked := SystemMem;
            TVCheckBox(TVForm(Ctrl).Ctrl('CB_VBlank')).Checked := VBlank;
            TVCheckBox(TVForm(Ctrl).Ctrl('CB_FPS')).Checked := ShowFPS;
            TVPanel(TVForm(Ctrl).Ctrl('Lab_Res')).Caption:=Format('%dx%dx%d',[DisplayWidth,DisplayHeight,DisplayBitCount]);
          end;
          ////
          if Ctrl = OptMIDI then
          begin
            TVCheckBox(TVForm(Ctrl).Ctrl('CB_Play')).Checked := PlayMIDI;

          end;
          /////
          if Ctrl = NewGameChar then
          with NewGameChar,PInfos[APlayer] do
           begin
            TVPanel(Ctrl('Pan_Player')).Caption:=Format(STR_PAN_PLAYER,[APlayer]);
            TVCheckBox(Ctrl('CB_Random')).Checked := RandomClass;
            TVCheckBox(Ctrl('CB_Human')).Checked := Human;
            TVCheckBox(Ctrl('CB_CPU')).Checked := not Human;
            TVEdit(Ctrl('Ed_Name')).Text := Name;
            TVGraphControl(Ctrl('Pan_COLOR')).Color:=Color;

          end;
          /////


        end;



    end;
  end;
end;

procedure TMorkin3.GlobalHandler(MSG: TVMSG);
begin
 with Wins do
 begin
  inherited;
  case MSG.Message of
  MSG_SURFRESIZE:begin Desk.SetBounds(WC.Desktop.GetBounds);WC.CenterVisible;MoveIngame;;end;

//  MSG_DRAWINITIALIZE:

  MSG_MOUSEFIRST..MSG_MOUSELAST,MSG_KEYFIRST..MSG_KEYLAST:if State=ST_INGAME then Engine.Input(MSG);


  end;
 end;


end;


procedure TMorkin3.SetState(Value: long);
begin
  inherited;
  with Wins do
  begin
    case State of
      ST_MAINMENU:
        begin
          if Engine<>nil then Engine.Unload;
          ShowWindows([MainMenu]);
          MIDPlay.PlayList.LoadFromItem(TextList.Items.Find(P_MAINMENU), lfList, playMIDI);

        end;
      ST_NEWGAME:
        begin
          ShowWindows([NewGameMain], false);


        end;
      ST_INGAME:
        begin
          Engine.Load;
          WC.RedrawAll;

          ShowWindows([MainView,S1Unit,S2Player,S3Menu]);
          //Desk.Hide;
          MoveIngame;

          MIDPlay.PlayList.LoadFromItem(TextList.Items.Find(P_INGAME), lfList, playMIDI);

        end;

    end;
  end;
end;



procedure TMorkin3.ShowWindows(Wins: array of TVForm; Hide: boolean);
begin
  inherited;
  with Self.Wins do
  begin
    Desk.Show;

  end;
end;

procedure TMorkin3.MoveInGame;
 begin
 with Wins do
 begin
  //MainView.Move(0,0);
  case DisplayWidth of
  700..850:
  begin
  MainView.SetBounds(0,0,600,600);
  SurfDrawer.SetBounds(10,1,576,576);
  end;
  950..1100:
  begin
  MainView.SetBounds(0,0,824,768);
  SurfDrawer.SetBounds(26,14,768,720);
  end;
  end;
  S1Unit.Move(S1Unit.Parent.Width-S1Unit.Width,0);
  S2Player.Move(S2Player.Parent.Width-S2Player.Width,S1Unit.Height);
  S3Menu.Move(S3Menu.Parent.Width-S3Menu.Width,S1Unit.Height+S2Player.Height);
  Updater.UpdateAll;
 end;
 end;

function TMorkin3.NextCol(Col:TColor):TColor;
var idx,i:long;
begin
 for i:=Low(PlayerColors)to High(PlayerColors)do
  if PlayerColors[i]=Col then idx:=i;

 if idx<High(PlayerColors) then Result:=PlayerColors[idx+1]
  else Result:=PlayerColors[Low(PlayerColors)];


end;

function TMorkin3.PrevCol(Col:TColor):TColor;
var idx,i:long;
begin
 for i:=Low(PlayerColors)to High(PlayerColors)do
  if PlayerColors[i]=Col then idx:=i;

 if idx>Low(PlayerColors) then Result:=PlayerColors[idx-1]
  else Result:=PlayerColors[High(PlayerColors)];

end;

procedure TMorkin3.DrawCredits(Sender:TObject);
var Surf:TAutoSurf;
begin
 Surf:=TVSurfDrawer(Sender).Surface;
 if Surf = nil then Exit;

 WC.Images.Items.Find('Vampyre').StretchDraw(Surf.Surf,Surf.Surf.ClientRect,0);
 FireFX.Redraw(Surf,Surf.Surf.ClientRect);

end;

procedure TWinCtrl.Init(AWC: TController);
begin
  with AWC do
  begin

    ////// WINDOWS
    MainMenu := Win(W_MAINMENU);
    Desk := WIN(W_DESK);
    NewGameMain := WIN(W_NEWGAMEMAIN);
    NewgameChar := WIN(W_NEWGAMECHAR);
    NewGamestory := WIN(W_NEWGAMESTORY);
    NewGameMap:=WIN(W_NEWGAMEMAP);
    LoadGame:=WIN(W_LOADGAME);
    Options := WIN(W_OPTIONS);
    OptGFX := WIN(W_OPTGFX);
    OptMIDI:=WIN(W_OPTMIDI);
    MainView:=WIN(W_MAINVIEW);
    S1Unit:=WIN(W_STATUS1);
    S2Player:=WIN(W_STATUS2);
    S3Menu:=WIN(W_STATUS3);
    Info:=WIN(W_INFO);
    Credits:=WIN(W_CREDITS);

     //// DRAWERS
    SurfDrawer:=TVSurfDrawer(MainView.CTRL(SD_MAIN));
    UnitDrawer:=TVSurfDrawer(S1Unit.CTRL(SD_UNIT));
    PlayerDrawer:=TVSurfDrawer(S2Player.CTRL(SD_PLAYER));
    CreditsDrawer:=TVSurfDrawer(Credits.CTRL(SD_CREDITS));

  end;
end;


constructor TUpdater.Create(AWins:TWinCtrl;AEngine:TEngine);
begin
 inherited Create;
 Wins:=AWins;
 Engine:=AEngine;
 with Wins do
 begin
  UnitDrawer.OnDraw:=RedrawUnit;
  PlayerDrawer.OnDraw:=RedrawPlayer;

 end;
end;


function TUpdater.UpdateUnitImg(AUnit:TChar):boolean;
var Surf:TDDsurf;
    Item:TPictureCollectionItem;
begin
 Result:=false;
 if AUnit=nil then Exit;
 if Wins.UnitDrawer.Surface=nil then Exit;
 Surf:=Wins.UnitDrawer.Surface.Surf;
 if Surf =nil then Exit;
 Surf.Fill(ColMatch(Surf,AUnit.Player.Color));

 Item:=AUnit.Images.Items.Find(AUnit.Image);
 if Item=nil then Exit;

 Item.Transparent:=true;
 Item.TransparentColor:=0;
 Item.StretchDraw(Surf,Surf.ClientRect,0);

 Result:=true;
end;

function TUpdater.UpdateUnitValues(AUnit:TChar):boolean;
 begin
  Result:=false;
  if AUnit=nil then Exit;
  with Wins.S1Unit do
  begin
   TVPanel(CTRL('LAB_HP')).Caption:=Format('%d/%d',[AUnit.HP,AUnit.MaxHP]);
   TVPanel(CTRL('LAB_MANA')).Caption:=Format('%d/%d',[AUnit.Mana,AUnit.MaxMana]);
   TVPanel(CTRL('LAB_MP')).Caption:=Format('%d/%d',[AUnit.MP,AUnit.MaxMP]);

  end;
 Result:=true;

 end;


function TUpdater.UpdateUnitAll(AUnit:TChar):boolean;
begin
 Result:=UpdateUnitImg(AUnit) and
 UpdateUnitValues(AUnit);
end;

function  TUpdater.UpdatePlayerImg(APlayer:TPlayer):boolean;
var Surf:TDDsurf;
    Item:TPictureCollectionItem;
begin
 Result:=false;
 if APlayer=nil then Exit;
 if Wins.PlayerDrawer.Surface=nil then Exit;
 Surf:=Wins.PlayerDrawer.Surface.Surf;
 if Surf =nil then Exit;
 Surf.Fill(ColMatch(Surf,APlayer.Color));

 Item:=APlayer.Images.Items.Find(APlayer.Image);
 if Item=nil then Exit;

 Item.Transparent:=true;
 Item.TransparentColor:=0;
 Item.StretchDraw(Surf,Surf.ClientRect,0);
 Result:=true;
end;

function TUpdater.UpdatePlayerValues(APlayer:TPlayer):boolean;
 begin
  Result:=false;
  if APlayer=nil then Exit;
  with Wins.S2Player do
  begin
   TVPanel(CTRL('LAB_UNITS')).Caption:=Format('%d/%d',[APlayer.Units-1,APlayer.Units]);
   TVPanel(CTRL('LAB_MANA')).Caption:=Format('%d/%d',[APlayer.Mana,APlayer.MaxMana]);
   TVPanel(CTRL('LAB_HP')).Caption:=Format('%d/%d',[APlayer.HP,APlayer.MaxHP]);
  end;
 Result:=true;
end;


function TUpdater.UpdatePlayerAll(APlayer:TPlayer):boolean;
begin
Result:=UpdatePlayerImg(APlayer)and
UpdatePlayerValues(APlayer);
end;

function TUpdater.UpdateAll:boolean;
 begin
  Result:=UpdateUnitAll(Engine.AUnit) and UpdatePlayerAll(Engine.APlayer);

 end;

procedure TUpdater.RedrawUnit(Sender:TObject);
begin
 UpdateUnitImg(Engine.AUnit);

end;

procedure TUpdater.RedrawPlayer(Sender:TObject);
begin
 UpdatePlayerImg(Engine.APlayer);


end;

end.

